#!/bin/bash
nexts=""
fl="/var/log/mail"
fs="B"
fd=""
fS=""
fe=""
fr=""
for i in "$@"; do
	case $i in
		-l) nexts="fl";;
		-f) nexts="ff";;
		-t) nexts="ft";;
		-r) nexts="fr";;
		-s) nexts="fs";;
		-d) nexts="fd";;
		-S) nexts="fS";;
		-h)
		echo "Используй $0 -f|-t e-mail [-r relay] [-l logfile] [-s [K|M|G]] [-d Mmm[_D[_HH[:MM[:SS]]]]] [-S state] -h"
		echo -e "\t-l логфайл;\n\t-f|-t e-mail отправителя|получателя;\n\t-r релей (по умолчанию все);\n\t-s единица измерения размера (по умолчанию байт);\n\t-d ограничить датой (например Nov_2_12:00:00);\n\t-S статус (например sent);\n\t-h вывод справки."; exit;;
		*)
		case $nexts in
			fl) fl="$i"; nexts="";;
			ff) fe="$i"; ftf="f"; nexts="";;
			ft) fe="$i"; ftf="t"; nexts="";;
			fr) fr="$i"; nexts="";;
			fs) fs="$i"; nexts="";;
			fd) fd="${i/ /  ?}"; nexts="";;
			fS) fS="$i"; nexts="";;
		esac
		;;
	esac
done
echo "Subject: \"$0 $*\""

test "$fl" || { echo "Не указан лог, использую по умолчанию!"; fl="/var/log/mail"; }
test -e $fl || { echo "Ошибка, $fl не существует"; exit; }
test "$fe" || { echo "Не указан e-mail отправителя или получателя."; $0 -h; exit; }

case $ftf in
	t) ftf_str="для";;
	f) ftf_str="от";;
esac
echo "Поиск писем $ftf_str $fe в $fl $(test "$fd" && echo "с фильтром по времени: \"$fd\"") $(test "$fS" && echo "с фильтром по статусу: \"$fS\"")"

fltype="${fl##*.}"
case $fltype in
        gz) GREP_BIN="/usr/bin/zgrep";;
        bz2) GREP_BIN="/usr/bin/bzgrep";;
        *) GREP_BIN="/usr/bin/grep";;
esac

case $fs in
        K) su=1024; size="KBytes";;
        M) su=1048576; size="MBytes";;
        G) su=1073741824; size="GBytes";;
        *) su=1; size="Bytes";;
esac

echo -n "Фильтрация лога. Это может занять некоторое время... "
starttime=$(date +%s.%N)
case $ftf in
	t)
		FILTERED_LOG="$($GREP_BIN -iE "^$fd.*: to=<$fe>, relay=$fr.*status=$fS" $fl)"
		FILTERED_ID="$(echo "$FILTERED_LOG" | awk '{print $6}' | sort -u | sed ':a; s/[:,]//g; /$/N; s/\n/|/; ta')"
		FILTERED_LOG1="$($GREP_BIN -iE "^$fd.*($FILTERED_ID): from=" $fl)"
		ID_SIZE="$(echo "$FILTERED_LOG1" | awk '{print $6";"$8}' | sort -u | sed ':a; s/[:,]//g; /$/N; s/\n/ /; ta')"
	;;
	f)
		ID_SIZE="$($GREP_BIN -iE "^$fd.*: from=<$fe>" $fl | awk '{print $6";"$8}' | sort -u | sed ':a; s/[:,]//g; /$/N; s/\n/ /; ta')"
		FILTERED_ID="$(echo "$ID_SIZE" | sed -e 's/;size=[0-9]*//g' -e 's/ /|/g')"
		FILTERED_LOG="$($GREP_BIN -E "^$fd.*($FILTERED_ID): to=<.*>, relay=$fr.*status=$fS" $fl)"
	;;
esac
echo "Готово"
SIZESALL=0
count=0
for i in $ID_SIZE; do
	ID="${i%%;size=*}"
	SIZEB="${i##*;size=}"
	SIZE="$(echo "scale=2; $SIZEB/$su" | bc -l)"
	case $ftf in
		t)
			fte="$(echo "$FILTERED_LOG1" | awk '/^'$fd'.*'$ID'.*: from=/ {print $7}' | sort --key=1)"
			MAILS="$(echo "$FILTERED_LOG" | awk '/^'$fd'.*'$ID'.*: to=<'$fe'>.*status='$fS'/ {print $8" "$11" "$12", "$1" "$2" "$3", '"$fte"' size='"$SIZE $size"'"}' | sort --key=1)"
		;;
		f)		
			MAILS="$(echo "$FILTERED_LOG" | awk '/^'$fd'.*'$ID'.*: to=<.*status='$fS'/ {print $8" "$11" "$12", "$1" "$2" "$3", "$7" size='"$SIZE $size"'"}' | sort --key=1)"
		;;
	esac
	mailcount=0
	SIZESN="0"
	if [ "$MAILS" ]; then
		echo -e "\nДля id=$ID:\n$MAILS"
		SIZES="$(echo "$MAILS" | sed -e 's/^.*size=//' -e 's/ '$size'$//')"
		for j in $SIZES; do SIZESN=$(echo "$SIZESN+$j" | bc -l); let mailcount=$mailcount+1; done
		echo -e "Всего найдено писем с id=$ID: $mailcount\tПолный размер: $SIZESN $size"
		let count=$count+1
	fi
	SIZESALL=$(echo "$SIZESALL+$SIZESN" | bc -l)
done
worktime=$(date -d "-$starttime seconds" "+%s.%N")
echo -e "\nВсего найдено уникальных id: $count\tПолный размер: $SIZESALL $size\t Затрачено времени(сек): $worktime"

